Index: NEMO/trunk/src/OCE/TRA/tramle.F90
===================================================================
--- NEMO/trunk/src/OCE/TRA/tramle.F90	(revision 14903)
+++ NEMO/trunk/src/OCE/TRA/tramle.F90	(revision 14921)
@@ -366,8 +366,4 @@
          r1_ft(:,:) = 1._wp / SQRT(  ff_t(:,:) * ff_t(:,:) + z1_t2  )
          !
-         ! Specifically, dbdx_mle, dbdy_mle and mld_prof need to be defined for nn_hls = 2
-         IF( nn_hls == 2 .AND. ln_osm_mle .AND. ln_zdfosm ) THEN
-            CALL ctl_stop('nn_hls = 2 cannot be used with ln_mle = ln_osm_mle = ln_zdfosm = T (zdfosm not updated for nn_hls = 2)')
-         ENDIF
       ENDIF
       !
Index: NEMO/trunk/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/trunk/src/OCE/ZDF/zdfosm.F90	(revision 14903)
+++ NEMO/trunk/src/OCE/ZDF/zdfosm.F90	(revision 14921)
@@ -34,116 +34,210 @@
    !! 16/05/2019 (19) Fox-Kemper parametrization of restratification through mixed layer eddies added to revised code.
    !! 23/05/19   (20) Old code where key_osmldpth1` is *not* set removed, together with the key key_osmldpth1
+   !!             4.2  !  2021-05  (S. Mueller)  Efficiency improvements, source-code clarity enhancements, and adaptation to tiling
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   'ln_zdfosm'                                             OSMOSIS scheme
+   !!   'ln_zdfosm'                                          OSMOSIS scheme
    !!----------------------------------------------------------------------
-   !!   zdf_osm       : update momentum and tracer Kz from osm scheme
-   !!   zdf_osm_init  : initialization, namelist read, and parameters control
-   !!   osm_rst       : read (or initialize) and write osmosis restart fields
-   !!   tra_osm       : compute and add to the T & S trend the non-local flux
-   !!   trc_osm       : compute and add to the passive tracer trend the non-local flux (TBD)
-   !!   dyn_osm       : compute and add to u & v trensd the non-local flux
-   !!
-   !! Subroutines in revised code.
+   !!   zdf_osm        : update momentum and tracer Kz from osm scheme
+   !!      zdf_osm_vertical_average             : compute vertical averages over boundary layers
+   !!      zdf_osm_velocity_rotation            : rotate velocity components
+   !!         zdf_osm_velocity_rotation_2d      :    rotation of 2d fields
+   !!         zdf_osm_velocity_rotation_3d      :    rotation of 3d fields
+   !!      zdf_osm_osbl_state                   : determine the state of the OSBL
+   !!      zdf_osm_external_gradients           : calculate gradients below the OSBL
+   !!      zdf_osm_calculate_dhdt               : calculate rate of change of hbl
+   !!      zdf_osm_timestep_hbl                 : hbl timestep
+   !!      zdf_osm_pycnocline_thickness         : calculate thickness of pycnocline
+   !!      zdf_osm_diffusivity_viscosity        : compute eddy diffusivity and viscosity profiles
+   !!      zdf_osm_fgr_terms                    : compute flux-gradient relationship terms
+   !!         zdf_osm_pycnocline_buoyancy_profiles : calculate pycnocline buoyancy profiles
+   !!      zdf_osm_zmld_horizontal_gradients    : calculate horizontal buoyancy gradients for use with Fox-Kemper parametrization
+   !!      zdf_osm_osbl_state_fk                : determine state of OSBL and MLE layers
+   !!      zdf_osm_mle_parameters               : timestep MLE depth and calculate MLE fluxes
+   !!   zdf_osm_init   : initialization, namelist read, and parameters control
+   !!      zdf_osm_alloc                        : memory allocation
+   !!   osm_rst        : read (or initialize) and write osmosis restart fields
+   !!   tra_osm        : compute and add to the T & S trend the non-local flux
+   !!   trc_osm        : compute and add to the passive tracer trend the non-local flux (TBD)
+   !!   dyn_osm        : compute and add to u & v trensd the non-local flux
+   !!   zdf_osm_iomput : iom_put wrapper that accepts arrays without halo
+   !!      zdf_osm_iomput_2d                    : iom_put wrapper for 2D fields
+   !!      zdf_osm_iomput_3d                    : iom_put wrapper for 3D fields
    !!----------------------------------------------------------------------
-   USE oce            ! ocean dynamics and active tracers
-                      ! uses ww from previous time step (which is now wb) to calculate hbl
-   USE dom_oce        ! ocean space and time domain
-   USE zdf_oce        ! ocean vertical physics
-   USE sbc_oce        ! surface boundary condition: ocean
-   USE sbcwave        ! surface wave parameters
-   USE phycst         ! physical constants
-   USE eosbn2         ! equation of state
-   USE traqsr         ! details of solar radiation absorption
-   USE zdfddm         ! double diffusion mixing (avs array)
-   USE iom            ! I/O library
-   USE lib_mpp        ! MPP library
-   USE trd_oce        ! ocean trends definition
-   USE trdtra         ! tracers trends
-   !
-   USE in_out_manager ! I/O manager
-   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
-   USE prtctl         ! Print control
-   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)
+   USE oce                       ! Ocean dynamics and active tracers
+   !                             ! Uses ww from previous time step (which is now wb) to calculate hbl
+   USE dom_oce                   ! Ocean space and time domain
+   USE zdf_oce                   ! Ocean vertical physics
+   USE sbc_oce                   ! Surface boundary condition: ocean
+   USE sbcwave                   ! Surface wave parameters
+   USE phycst                    ! Physical constants
+   USE eosbn2                    ! Equation of state
+   USE traqsr                    ! Details of solar radiation absorption
+   USE zdfdrg, ONLY : rCdU_bot   ! Bottom friction velocity
+   USE zdfddm                    ! Double diffusion mixing (avs array)
+   USE iom                       ! I/O library
+   USE lib_mpp                   ! MPP library
+   USE trd_oce                   ! Ocean trends definition
+   USE trdtra                    ! Tracers trends
+   USE in_out_manager            ! I/O manager
+   USE lbclnk                    ! Ocean lateral boundary conditions (or mpp link)
+   USE prtctl                    ! Print control
+   USE lib_fortran               ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   zdf_osm       ! routine called by step.F90
-   PUBLIC   zdf_osm_init  ! routine called by nemogcm.F90
-   PUBLIC   osm_rst       ! routine called by step.F90
-   PUBLIC   tra_osm       ! routine called by step.F90
-   PUBLIC   trc_osm       ! routine called by trcstp.F90
-   PUBLIC   dyn_osm       ! routine called by step.F90
-
-   PUBLIC   ln_osm_mle    ! logical needed by tra_mle_init in tramle.F90
-
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghamu    !: non-local u-momentum flux
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghamv    !: non-local v-momentum flux
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghamt    !: non-local temperature flux (gamma/<ws>o)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghams    !: non-local salinity flux (gamma/<ws>o)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   etmean   !: averaging operator for avt
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hbl      !: boundary layer depth
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dh       ! depth of pycnocline
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hml      ! ML depth
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dstokes  !: penetration depth of the Stokes drift.
-
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)           ::   r1_ft    ! inverse of the modified Coriolis parameter at t-pts
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hmle     ! Depth of layer affexted by mixed layer eddies in Fox-Kemper parametrization
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dbdx_mle ! zonal buoyancy gradient in ML
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dbdy_mle ! meridional buoyancy gradient in ML
-   INTEGER,  PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   mld_prof ! level of base of MLE layer.
-
-   !                      !!** Namelist  namzdf_osm  **
-   LOGICAL  ::   ln_use_osm_la      ! Use namelist  rn_osm_la
-
-   LOGICAL  ::   ln_osm_mle           !: flag to activate the Mixed Layer Eddy (MLE) parameterisation
-
-   REAL(wp) ::   rn_osm_la          ! Turbulent Langmuir number
-   REAL(wp) ::   rn_osm_dstokes     ! Depth scale of Stokes drift
-   REAL(wp) ::   rn_zdfosm_adjust_sd = 1.0 ! factor to reduce Stokes drift by
-   REAL(wp) ::   rn_osm_hblfrac = 0.1! for nn_osm_wave = 3/4 specify fraction in top of hbl
-   LOGICAL  ::   ln_zdfosm_ice_shelter      ! flag to activate ice sheltering
-   REAL(wp) ::   rn_osm_hbl0 = 10._wp       ! Initial value of hbl for 1D runs
-   INTEGER  ::   nn_ave             ! = 0/1 flag for horizontal average on avt
-   INTEGER  ::   nn_osm_wave = 0    ! = 0/1/2 flag for getting stokes drift from La# / PM wind-waves/Inputs into sbcwave
-   INTEGER  ::   nn_osm_SD_reduce   ! = 0/1/2 flag for getting effective stokes drift from surface value
-   LOGICAL  ::   ln_dia_osm         ! Use namelist  rn_osm_la
-
-
-   LOGICAL  ::   ln_kpprimix  = .true.  ! Shear instability mixing
-   REAL(wp) ::   rn_riinfty   = 0.7     ! local Richardson Number limit for shear instability
-   REAL(wp) ::   rn_difri    =  0.005   ! maximum shear mixing at Rig = 0    (m2/s)
-   LOGICAL  ::   ln_convmix  = .true.   ! Convective instability mixing
-   REAL(wp) ::   rn_difconv = 1._wp     ! diffusivity when unstable below BL  (m2/s)
-
-! OSMOSIS mixed layer eddy parametrization constants
-   INTEGER  ::   nn_osm_mle             ! = 0/1 flag for horizontal average on avt
-   REAL(wp) ::   rn_osm_mle_ce           ! MLE coefficient
-   !                                        ! parameters used in nn_osm_mle = 0 case
-   REAL(wp) ::   rn_osm_mle_lf               ! typical scale of mixed layer front
-   REAL(wp) ::   rn_osm_mle_time             ! time scale for mixing momentum across the mixed layer
-   !                                        ! parameters used in nn_osm_mle = 1 case
-   REAL(wp) ::   rn_osm_mle_lat              ! reference latitude for a 5 km scale of ML front
-   LOGICAL  ::   ln_osm_hmle_limit           ! If true arbitrarily restrict hmle to rn_osm_hmle_limit*zmld
-   REAL(wp) ::   rn_osm_hmle_limit           ! If ln_osm_hmle_limit true arbitrarily restrict hmle to rn_osm_hmle_limit*zmld
-   REAL(wp) ::   rn_osm_mle_rho_c        ! Density criterion for definition of MLD used by FK
-   REAL(wp) ::   r5_21 = 5.e0 / 21.e0   ! factor used in mle streamfunction computation
-   REAL(wp) ::   rb_c                   ! ML buoyancy criteria = g rho_c /rho0 where rho_c is defined in zdfmld
-   REAL(wp) ::   rc_f                   ! MLE coefficient (= rn_ce / (5 km * fo) ) in nn_osm_mle=1 case
-   REAL(wp) ::   rn_osm_mle_thresh          ! Threshold buoyancy for deepening of MLE layer below OSBL base.
-   REAL(wp) ::   rn_osm_bl_thresh          ! Threshold buoyancy for deepening of OSBL base.
-   REAL(wp) ::   rn_osm_mle_tau             ! Adjustment timescale for MLE.
-
-
-   !                                    !!! ** General constants  **
-   REAL(wp) ::   epsln   = 1.0e-20_wp   ! a small positive number to ensure no div by zero
-   REAL(wp) ::   depth_tol = 1.0e-6_wp  ! a small-ish positive number to give a hbl slightly shallower than gdepw
-   REAL(wp) ::   pthird  = 1._wp/3._wp  ! 1/3
-   REAL(wp) ::   p2third = 2._wp/3._wp  ! 2/3
-
-   INTEGER :: idebug = 236
-   INTEGER :: jdebug = 228
+   ! Public subroutines
+   PUBLIC zdf_osm        ! Routine called by step.F90
+   PUBLIC zdf_osm_init   ! Routine called by nemogcm.F90
+   PUBLIC osm_rst        ! Routine called by step.F90
+   PUBLIC tra_osm        ! Routine called by step.F90
+   PUBLIC trc_osm        ! Routine called by trcstp.F90
+   PUBLIC dyn_osm        ! Routine called by step.F90
+
+   ! Public variables
+   LOGICAL,  PUBLIC                                      ::   ln_osm_mle   !: Flag to activate the Mixed Layer Eddy (MLE)
+   !                                                                       !     parameterisation, needed by tra_mle_init in
+   !                                                                       !     tramle.F90
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghamu        !: Non-local u-momentum flux
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghamv        !: Non-local v-momentum flux
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghamt        !: Non-local temperature flux (gamma/<ws>o)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ghams        !: Non-local salinity flux (gamma/<ws>o)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hbl          !: Boundary layer depth
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hml          !: ML depth
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hmle         !: Depth of layer affexted by mixed layer eddies in Fox-Kemper parametrization
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dbdx_mle     !: Zonal buoyancy gradient in ML
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dbdy_mle     !: Meridional buoyancy gradient in ML
+   INTEGER,  PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   mld_prof     !: Level of base of MLE layer
+
+   INTERFACE zdf_osm_velocity_rotation
+      !!---------------------------------------------------------------------
+      !!              ***  INTERFACE zdf_velocity_rotation  ***
+      !!---------------------------------------------------------------------
+      MODULE PROCEDURE zdf_osm_velocity_rotation_2d
+      MODULE PROCEDURE zdf_osm_velocity_rotation_3d
+   END INTERFACE
+   !
+   INTERFACE zdf_osm_iomput
+      !!---------------------------------------------------------------------
+      !!                 ***  INTERFACE zdf_osm_iomput  ***
+      !!---------------------------------------------------------------------
+      MODULE PROCEDURE zdf_osm_iomput_2d
+      MODULE PROCEDURE zdf_osm_iomput_3d
+   END INTERFACE
+
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   etmean      ! Averaging operator for avt
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dh          ! Depth of pycnocline
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   r1_ft       ! Inverse of the modified Coriolis parameter at t-pts
+   ! Layer indices
+   INTEGER,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   nbld        ! Level of boundary layer base
+   INTEGER,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   nmld        ! Level of mixed-layer depth (pycnocline top)
+   ! Layer type
+   INTEGER,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   n_ddh       ! Type of shear layer
+   !                                                              !    n_ddh=0: active shear layer
+   !                                                              !    n_ddh=1: shear layer not active
+   !                                                              !    n_ddh=2: shear production low
+   ! Layer flags
+   LOGICAL,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   l_conv      ! Unstable/stable bl
+   LOGICAL,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   l_shear     ! Shear layers
+   LOGICAL,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   l_coup      ! Coupling to bottom
+   LOGICAL,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   l_pyc       ! OSBL pycnocline present
+   LOGICAL,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   l_flux      ! Surface flux extends below OSBL into MLE layer
+   LOGICAL,  ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   l_mle       ! MLE layer increases in hickness.
+   ! Scales
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   swth0       ! Surface heat flux (Kinematic)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sws0        ! Surface freshwater flux
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   swb0        ! Surface buoyancy flux
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   suw0        ! Surface u-momentum flux
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sustar      ! Friction velocity
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   scos_wind   ! Cos angle of surface stress
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ssin_wind   ! Sin angle of surface stress
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   swthav      ! Heat flux - bl average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   swsav       ! Freshwater flux - bl average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   swbav       ! Buoyancy flux - bl average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sustke      ! Surface Stokes drift
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   dstokes     ! Penetration depth of the Stokes drift
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   swstrl      ! Langmuir velocity scale
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   swstrc      ! Convective velocity scale
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sla         ! Trubulent Langmuir number
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   svstr       ! Velocity scale that tends to sustar for large Langmuir number
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   shol        ! Stability parameter for boundary layer
+   ! Layer averages: BL
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_t_bl     ! Temperature average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_s_bl     ! Salinity average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_u_bl     ! Velocity average (u)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_v_bl     ! Velocity average (v)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_b_bl     ! Buoyancy average
+   ! Difference between layer average and parameter at the base of the layer: BL
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_dt_bl    ! Temperature difference
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_ds_bl    ! Salinity difference
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_du_bl    ! Velocity difference (u)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_dv_bl    ! Velocity difference (v)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_db_bl    ! Buoyancy difference
+   ! Layer averages: ML
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_t_ml     ! Temperature average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_s_ml     ! Salinity average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_u_ml     ! Velocity average (u)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_v_ml     ! Velocity average (v)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_b_ml     ! Buoyancy average
+   ! Difference between layer average and parameter at the base of the layer: ML
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_dt_ml    ! Temperature difference
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_ds_ml    ! Salinity difference
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_du_ml    ! Velocity difference (u)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_dv_ml    ! Velocity difference (v)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_db_ml    ! Buoyancy difference
+   ! Layer averages: MLE
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_t_mle    ! Temperature average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_s_mle    ! Salinity average
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_u_mle    ! Velocity average (u)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_v_mle    ! Velocity average (v)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   av_b_mle    ! Buoyancy average
+   ! Diagnostic output
+   REAL(WP), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   osmdia2d    ! Auxiliary array for diagnostic output
+   REAL(WP), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   osmdia3d    ! Auxiliary array for diagnostic output
+   LOGICAL  ::   ln_dia_pyc_scl = .FALSE.                         ! Output of pycnocline scalar-gradient profiles
+   LOGICAL  ::   ln_dia_pyc_shr = .FALSE.                         ! Output of pycnocline velocity-shear  profiles
+
+   !                                               !!* namelist namzdf_osm *
+   LOGICAL  ::   ln_use_osm_la                      ! Use namelist rn_osm_la
+   REAL(wp) ::   rn_osm_la                          ! Turbulent Langmuir number
+   REAL(wp) ::   rn_osm_dstokes                     ! Depth scale of Stokes drift
+   REAL(wp) ::   rn_zdfosm_adjust_sd   = 1.0_wp     ! Factor to reduce Stokes drift by
+   REAL(wp) ::   rn_osm_hblfrac        = 0.1_wp     ! For nn_osm_wave = 3/4 specify fraction in top of hbl
+   LOGICAL  ::   ln_zdfosm_ice_shelter              ! Flag to activate ice sheltering
+   REAL(wp) ::   rn_osm_hbl0           = 10.0_wp    ! Initial value of hbl for 1D runs
+   INTEGER  ::   nn_ave                             ! = 0/1 flag for horizontal average on avt
+   INTEGER  ::   nn_osm_wave = 0                    ! = 0/1/2 flag for getting stokes drift from La# / PM wind-waves/Inputs into
+   !                                                !    sbcwave
+   INTEGER  ::   nn_osm_SD_reduce                   ! = 0/1/2 flag for getting effective stokes drift from surface value
+   LOGICAL  ::   ln_dia_osm                         ! Use namelist  rn_osm_la
+   LOGICAL  ::   ln_kpprimix           = .TRUE.     ! Shear instability mixing
+   REAL(wp) ::   rn_riinfty            = 0.7_wp     ! Local Richardson Number limit for shear instability
+   REAL(wp) ::   rn_difri              = 0.005_wp   ! Maximum shear mixing at Rig = 0    (m2/s)
+   LOGICAL  ::   ln_convmix            = .TRUE.     ! Convective instability mixing
+   REAL(wp) ::   rn_difconv            = 1.0_wp     ! Diffusivity when unstable below BL  (m2/s)
+   ! OSMOSIS mixed layer eddy parametrization constants
+   INTEGER  ::   nn_osm_mle                         ! = 0/1 flag for horizontal average on avt
+   REAL(wp) ::   rn_osm_mle_ce                      ! MLE coefficient
+   !    Parameters used in nn_osm_mle = 0 case
+   REAL(wp) ::   rn_osm_mle_lf                      ! Typical scale of mixed layer front
+   REAL(wp) ::   rn_osm_mle_time                    ! Time scale for mixing momentum across the mixed layer
+   !    Parameters used in nn_osm_mle = 1 case
+   REAL(wp) ::   rn_osm_mle_lat                     ! Reference latitude for a 5 km scale of ML front
+   LOGICAL  ::   ln_osm_hmle_limit                  ! If true arbitrarily restrict hmle to rn_osm_hmle_limit*zmld
+   REAL(wp) ::   rn_osm_hmle_limit                  ! If ln_osm_hmle_limit true arbitrarily restrict hmle to rn_osm_hmle_limit*zmld
+   REAL(wp) ::   rn_osm_mle_rho_c                   ! Density criterion for definition of MLD used by FK
+   REAL(wp) ::   rb_c                               ! ML buoyancy criteria = g rho_c /rho0 where rho_c is defined in zdfmld
+   REAL(wp) ::   rc_f                               ! MLE coefficient (= rn_ce / (5 km * fo) ) in nn_osm_mle=1 case
+   REAL(wp) ::   rn_osm_mle_thresh                  ! Threshold buoyancy for deepening of MLE layer below OSBL base
+   REAL(wp) ::   rn_osm_bl_thresh                   ! Threshold buoyancy for deepening of OSBL base
+   REAL(wp) ::   rn_osm_mle_tau                     ! Adjustment timescale for MLE
+
+   ! General constants
+   REAL(wp) ::   epsln     = 1.0e-20_wp      ! A small positive number to ensure no div by zero
+   REAL(wp) ::   depth_tol = 1.0e-6_wp       ! A small-ish positive number to give a hbl slightly shallower than gdepw
+   REAL(wp) ::   pthird    = 1.0_wp/3.0_wp   ! 1/3
+   REAL(wp) ::   p2third   = 2.0_wp/3.0_wp   ! 2/3
 
    !! * Substitutions
@@ -161,18 +255,65 @@
       !!                 ***  FUNCTION zdf_osm_alloc  ***
       !!----------------------------------------------------------------------
-     ALLOCATE( ghamu(jpi,jpj,jpk), ghamv(jpi,jpj,jpk), ghamt(jpi,jpj,jpk),ghams(jpi,jpj,jpk), &
-          &       hbl(jpi,jpj), dh(jpi,jpj), hml(jpi,jpj), dstokes(jpi, jpj), &
-          &       etmean(jpi,jpj,jpk), STAT= zdf_osm_alloc )
-
-     ALLOCATE(  hmle(jpi,jpj), r1_ft(jpi,jpj), dbdx_mle(jpi,jpj), dbdy_mle(jpi,jpj), &
-          &       mld_prof(jpi,jpj), STAT= zdf_osm_alloc )
-
-     CALL mpp_sum ( 'zdfosm', zdf_osm_alloc )
-     IF( zdf_osm_alloc /= 0 )   CALL ctl_warn('zdf_osm_alloc: failed to allocate zdf_osm arrays')
-
+      INTEGER ::   ierr
+      !!----------------------------------------------------------------------
+      !
+      zdf_osm_alloc = 0
+      !
+      ALLOCATE( ghamu(jpi,jpj,jpk), ghamv(jpi,jpj,jpk), ghamt(jpi,jpj,jpk), ghams(jpi,jpj,jpk), hbl(jpi,jpj), hml(jpi,jpj),   &
+         &      hmle(jpi,jpj),      dbdx_mle(jpi,jpj),  dbdy_mle(jpi,jpj),  mld_prof(jpi,jpj),  STAT=ierr )
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( etmean(A2D(nn_hls-1),jpk), dh(jpi,jpj), r1_ft(A2D(nn_hls-1)), STAT=ierr )
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( nbld(jpi,jpj), nmld(A2D(nn_hls-1)), STAT=ierr )
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( n_ddh(A2D(nn_hls-1)), STAT=ierr )
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( l_conv(A2D(nn_hls-1)), l_shear(A2D(nn_hls-1)), l_coup(A2D(nn_hls-1)), l_pyc(A2D(nn_hls-1)),   &
+         &      l_flux(A2D(nn_hls-1)), l_mle(A2D(nn_hls-1)),   STAT=ierr )
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( swth0(A2D(nn_hls-1)),  sws0(A2D(nn_hls-1)),      swb0(A2D(nn_hls-1)),      suw0(A2D(nn_hls-1)),      &
+         &      sustar(A2D(nn_hls-1)), scos_wind(A2D(nn_hls-1)), ssin_wind(A2D(nn_hls-1)), swthav(A2D(nn_hls-1)),    &
+         &      swsav(A2D(nn_hls-1)),  swbav(A2D(nn_hls-1)),     sustke(A2D(nn_hls-1)),    dstokes(A2D(nn_hls-1)),   &
+         &      swstrl(A2D(nn_hls-1)), swstrc(A2D(nn_hls-1)),    sla(A2D(nn_hls-1)),       svstr(A2D(nn_hls-1)),     &
+         &      shol(A2D(nn_hls-1)),   STAT=ierr )
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( av_t_bl(jpi,jpj), av_s_bl(jpi,jpj), av_u_bl(jpi,jpj), av_v_bl(jpi,jpj),   &
+         &      av_b_bl(jpi,jpj), STAT=ierr)
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( av_dt_bl(jpi,jpj), av_ds_bl(jpi,jpj), av_du_bl(jpi,jpj), av_dv_bl(jpi,jpj),   &
+         &      av_db_bl(jpi,jpj), STAT=ierr)
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( av_t_ml(jpi,jpj), av_s_ml(jpi,jpj), av_u_ml(jpi,jpj), av_v_ml(jpi,jpj),   &
+         &      av_b_ml(jpi,jpj), STAT=ierr)
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( av_dt_ml(jpi,jpj), av_ds_ml(jpi,jpj), av_du_ml(jpi,jpj), av_dv_ml(jpi,jpj),   &
+         &      av_db_ml(jpi,jpj), STAT=ierr)
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      ALLOCATE( av_t_mle(jpi,jpj), av_s_mle(jpi,jpj), av_u_mle(jpi,jpj), av_v_mle(jpi,jpj),   &
+         &      av_b_mle(jpi,jpj), STAT=ierr)
+      zdf_osm_alloc = zdf_osm_alloc + ierr
+      !
+      IF ( ln_dia_osm ) THEN
+         ALLOCATE( osmdia2d(jpi,jpj), osmdia3d(jpi,jpj,jpk), STAT=ierr )
+         zdf_osm_alloc = zdf_osm_alloc + ierr
+      END IF
+      !
+      CALL mpp_sum ( 'zdfosm', zdf_osm_alloc )
+      IF( zdf_osm_alloc /= 0 ) CALL ctl_warn( 'zdf_osm_alloc: failed to allocate zdf_osm arrays' )
+      !
    END FUNCTION zdf_osm_alloc
 
-
-   SUBROUTINE zdf_osm( kt, Kbb, Kmm, Krhs, p_avm, p_avt )
+   SUBROUTINE zdf_osm( kt, Kbb, Kmm, Krhs, p_avm,   &
+      &                p_avt )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE zdf_osm  ***
